]> git.phdru.name Git - dotfiles.git/blob - .shellrc
Refactor: Use `$#` to check parameters
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    has_completion() { return 0; }
75    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
76       if [ "$SHELL" = /bin/bash ]; then
77          if [ -d /usr/share/bash-completion ]; then
78             . /usr/share/bash-completion/bash_completion
79             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
80          elif [ -f /etc/bash_completion ]; then
81             . /etc/bash_completion
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          elif [ -d /etc/bash_completion.d ]; then
84             for _compf in /etc/bash_completion.d/*; do
85                . $_compf
86             done
87             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
88          fi
89       elif [ "$SHELL" = /usr/local/bin/bash ]; then
90          if [ -d /usr/local/etc/bash_completion.d ]; then
91             for _compf in /usr/local/etc/bash_completion.d/*; do
92                . $_compf
93             done
94             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
95          fi
96       else
97          echo "Unknown OS type, cannot source bash_completion" >&2
98       fi
99    fi
100
101    if [ -d "$HOME"/.bash_completion.d ]; then
102       for _compf in "$HOME"/.bash_completion.d/*; do
103          . $_compf
104       done
105    fi
106
107    for cmd in builtin cgmem_nice command dbus-launch exec \
108       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
109       time whence whereis which xargs; do
110          ! has_completion $cmd && complete -o default -A command $cmd
111    done
112
113    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
114       telnet t tt \
115       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
116       whois wget wget-m wget-wrapper ww; do
117          ! has_completion $cmd && complete -A hostname $cmd
118    done
119
120    for cmd in distribute ftp lftp r rsync \
121       s scp ssh smbclient tcpdump tshark wireshark; do
122          ! has_completion $cmd && complete -o default -A hostname $cmd;
123    done
124
125    delegate_completion() {
126       local prog programs
127       prog=$1
128       if has_completion $prog; then
129          shift
130          programs="$@"
131          eval "_${prog}_completion_loader() {
132             _completion_loader $prog
133             complete -F _$prog $programs
134             unset _${prog}_completion_loader
135             return 124
136          }"
137          complete -F _${prog}_completion_loader $programs
138       fi
139    }
140
141    delegate_completion make m
142    delegate_completion ping p
143    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
144    delegate_completion ssh s
145    delegate_completion wget wget-m wget-wrapper ww
146
147    unset has_completion delegate_completion
148
149    complete -A job bg fg j jobs wait
150    complete -A variable -A function unset
151
152    if [ -d "$HOME/lib/config" ]; then
153       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
154    fi
155    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
156
157    #if type -p pip >/dev/null 2>&1; then
158    #   eval "`pip completion --bash`"
159    #   rm -rf /tmp/pip_build_"$USER"
160    #fi
161
162    #if which pyenv >/dev/null 2>&1; then
163    #   eval "`pyenv init -`"
164    #   eval "`pyenv virtualenv-init -`"
165    #fi
166
167    source virtualenvwrapper_lazy.sh 2>/dev/null
168
169    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
170       . "$VIRTUAL_ENV/bin/activate"
171    fi
172
173    # Clean up python virtual environment on exit
174    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
175
176    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
177
178 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
179    back() { cd - "$@"; }
180    j() { jobs; }
181 fi
182
183
184 # clear screen and history, logout
185 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
186
187
188 if test -x /usr/bin/git >/dev/null 2>&1; then
189    # chdir to a directory
190    cdgitpath() {
191       if [ $# -ne 1 ]; then
192          echo "Usage: cdgitpath path_key" >&2
193          return 1
194       fi
195
196       path_key="$1"
197       if [ -z "$path_key" ]; then
198          echo "Usage: cdgitpath path_key" >&2
199          return 1
200       fi
201
202       cd "`git config --get --path $path_key`"
203    }
204
205    # chdir to a remote's directory (if the remote is on the local FS)
206    cdremote() {
207       if [ $# -gt 1 ]; then
208          echo "Usage: cdremote [remote_name]" >&2
209          return 1
210       fi
211
212       if [ -z "$1" ]; then
213          branch="`git rev-parse --abbrev-ref HEAD`"
214          remote="`git config --get branch.$branch.remote`"
215       else
216          remote="$1"
217       fi
218
219       if [ -z "$remote" ]; then
220          echo "Cannot find remote for branch $branch" >&2
221          echo "Usage: cdremote [remote_name]" >&2
222          return 1
223       fi
224
225       if git config --get remote.$remote.url | grep -q '^\(/\|\.\./\)'; then
226          cdgitpath remote.$remote.url
227       else
228
229          if [ -n "$1" ]; then
230             echo "Cannot find directory for remote $1" >&2
231             echo "Usage: cdremote [remote_name]" >&2
232             return 1
233          fi
234
235          _list_remotes '^\(/\|\.\./\)' # (/ or ../ at the beginning)
236          if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
237             remote=${GIT_REMOTES[0]}
238             unset GIT_REMOTES
239             cdgitpath remote.$remote.url
240          else
241             unset GIT_REMOTES
242             echo "Cannot find directory for any remote" >&2
243             echo "Usage: cdremote [remote_name]" >&2
244             return 1
245          fi
246       fi
247    }
248
249    if test -n "$BASH_VERSION"; then
250       # completion for aliases in global .gitconfig
251
252       # fixup rbi rbia rbiap rbip - do refs name completion
253       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
254       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
255       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
256       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
257       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
258       #
259       # push-to-all-remotes - do branch name completion
260       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
261
262       _cdgitpath_completion_loader() {
263          _completion_loader git
264          complete -F _cdgitpath_complete cdgitpath git-open
265          unset _cdgitpath_completion_loader
266          return 124
267       }
268
269       _cdgitpath_complete() {
270          local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
271          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
272       }
273
274       _git_open() {
275          _cdgitpath_complete
276       }
277
278       complete -F _cdgitpath_completion_loader cdgitpath git-open
279
280       # list remotes with URLs matching a regexp
281       _list_remotes() {
282          if [ $#  -ne 1 ]; then
283             echo "Usage: _list_remotes remote_regexp" >&2
284             return 1
285          fi
286          declare -ag GIT_REMOTES=()
287          local remote
288          for remote in `git remote`; do
289             if git config --get remote.$remote.url | grep -q "$1"; then
290                GIT_REMOTES+=($remote)
291             fi
292          done
293       }
294
295       # completion for cdremote and git-open-remote - list remotes with a pattern
296       _list_remotes_completion() {
297          local cur="${COMP_WORDS[COMP_CWORD]}";
298          _list_remotes "$1"
299          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
300          unset GIT_REMOTES
301       }
302
303       # completion for cdremote - list remotes with directories as URLs
304       _cdremote_complete() {
305          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
306          if [ ${#COMPREPLY[*]} -eq 0 ]; then
307             _list_remotes_completion .
308          fi
309       }
310
311       complete -F _cdremote_complete cdremote
312
313       # completion for git-open-remote - list remotes with http(s) URLs
314       _git_open_remote() {
315          _list_remotes_completion '^http\(s\)\?://'
316          if [ ${#COMPREPLY[*]} -eq 0 ]; then
317             _list_remotes_completion .
318          fi
319       }
320
321       complete -F _git_open_remote git-open-remote
322    fi
323 fi
324
325
326 include() {
327    cfg="$1"
328    if [ -f "./$cfg" -a -r "./$cfg" ]; then
329       echo "Reading config file \`$cfg'" 1>&2
330       . "./$cfg"
331    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
332       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
333       . "$HOME/lib/config/$cfg"
334    else
335       echo "Cannot find config file \`$cfg'" 1>&2
336    fi
337 }
338
339
340 mc() {
341    if test -n "$BASH_VERSION"; then
342       MC_SAVE_OPS1="$OPS1"
343       OPS1="\u@\h "
344    fi
345
346    if [ -n "$SLOWTERM" ]; then
347       MC_SLOW="--slow"
348    fi
349
350    case "$TERM" in
351       screen*) # screen, screen.rxvt
352          MC_XTERM="-x"
353       ;;
354    esac
355
356    #TMPDIR="$HOME"/tmp
357    #export TMPDIR
358
359    MC_FOUND=NO
360
361    for wrapper in \
362          /usr/local/share/mc/bin/mc-wrapper.sh \
363          /usr/local/libexec/mc/mc-wrapper.sh \
364          /usr/share/mc/bin/mc-wrapper.sh; do
365       if [ -r $wrapper ]; then
366          . $wrapper $MC_SLOW $MC_XTERM "$@"
367          rc=$?
368          MC_FOUND=YES
369          break
370       fi
371    done
372
373    if [ $MC_FOUND = NO ]; then
374       for mc in /usr/local/bin/mc /usr/bin/mc; do
375          if [ -x $mc ]; then
376             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
377             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
378                MC_TMP_DIR="${TMPDIR-/tmp}"
379             fi
380             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
381             mc_type="`mc_type.py $mc`"
382             if [ "$mc_type" = old ]; then
383                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
384             elif [ "$mc_type" = new ]; then
385                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
386             else
387                continue
388             fi
389             rc=$?
390             MC_FOUND=YES
391             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
392             break
393          fi
394       done
395    fi
396
397    if [ $MC_FOUND = NO ]; then
398       echo "Cannot find mc-wrapper.sh or mc" >&2
399       rc=1
400    fi
401
402    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
403    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
404
405    return $rc
406 }
407
408
409 mkcd() {
410    if [ $# -ne 1 ]; then
411       echo "Usage: mkcd directory_name" >&2
412    elif [ -d "$1" ]; then
413       cd "$1"
414    elif [ -e "$1" ]; then
415       echo "Error: $1 is a file" >&2
416    else
417       mkdir -p "$1" && cd "$1"
418    fi
419 }
420
421
422 if which tmux >/dev/null 2>&1; then
423    tmux() {
424       case "$TERM" in
425          rxvt)
426             TERM=rxvt-unicode command tmux "$@"
427          ;;
428
429          *)
430             command tmux "$@"
431          ;;
432       esac
433    }
434 fi
435
436
437 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
438    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
439 fi
440
441 x() { exit; }